# Method: projects.locations.appConnectors.resolveInstanceConfig

- [HTTP request](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#body.PATH_PARAMETERS)
- [Request body](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#body.request_body)
- [Response body](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#body.ResolveInstanceConfigResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#body.aspect)
- [AppConnectorInstanceConfig](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#AppConnectorInstanceConfig)
  - [JSON representation](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#AppConnectorInstanceConfig.SCHEMA_REPRESENTATION)
- [NotificationConfig](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#NotificationConfig)
  - [JSON representation](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#NotificationConfig.SCHEMA_REPRESENTATION)
- [CloudPubSubNotificationConfig](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#CloudPubSubNotificationConfig)
  - [JSON representation](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#CloudPubSubNotificationConfig.SCHEMA_REPRESENTATION)
- [ImageConfig](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#ImageConfig)
  - [JSON representation](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#ImageConfig.SCHEMA_REPRESENTATION)
- [Try it!](https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#try-it)

Gets instance configuration for a given AppConnector. An internal method called by a AppConnector to get its container config.

### HTTP request

`GET https://beyondcorp.googleapis.com/v1/{appConnector=projects/*/locations/*/appConnectors/*}:resolveInstanceConfig`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `appConnector` | `string` Required. BeyondCorp AppConnector name using the form: `projects/{projectId}/locations/{locationId}/appConnectors/{appConnector}` Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `appConnector`: - `beyondcorp.appConnectors.list` |

### Request body

The request body must be empty.

### Response body

Response message for BeyondCorp.ResolveInstanceConfig.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "instanceConfig": { object (`https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#AppConnectorInstanceConfig`) } } ``` |

| Fields ||
|---|---|
| `instanceConfig` | ``object (`https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#AppConnectorInstanceConfig`)`` AppConnectorInstanceConfig. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/cloud-platform`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

## AppConnectorInstanceConfig

AppConnectorInstanceConfig defines the instance config of a AppConnector.

| JSON representation |
|---|
| ``` { "sequenceNumber": string, "instanceConfig": { "@type": string, field1: ..., ... }, "notificationConfig": { object (`https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#NotificationConfig`) }, "imageConfig": { object (`https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#ImageConfig`) } } ``` |

| Fields ||
|---|---|
| `sequenceNumber` | `string (https://developers.google.com/discovery/v1/type-format format)` Required. A monotonically increasing number generated and maintained by the API provider. Every time a config changes in the backend, the sequenceNumber should be bumped up to reflect the change. |
| `instanceConfig` | `object` The SLM instance agent configuration. An object containing fields of an arbitrary type. An additional field `"@type"` contains a URI identifying the type. Example: `{ "id": 1234, "@type": "types.example.com/standard/id" }`. |
| `notificationConfig` | ``object (`https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#NotificationConfig`)`` NotificationConfig defines the notification mechanism that the remote instance should subscribe to in order to receive notification. |
| `imageConfig` | ``object (`https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#ImageConfig`)`` ImageConfig defines the GCR images to run for the remote agent's control plane. |

## NotificationConfig

NotificationConfig defines the mechanisms to notify instance agent.

| JSON representation |
|---|
| ``` { // Union field `config` can be only one of the following: "pubsubNotification": { object (`https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#CloudPubSubNotificationConfig`) } // End of list of possible types for union field `config`. } ``` |

| Fields ||
|---|---|
| Union field `config`. `config` can be only one of the following: ||
| `pubsubNotification` | ``object (`https://docs.cloud.google.com/chrome-enterprise-premium/docs/reference/rest/v1/projects.locations.appConnectors/resolveInstanceConfig#CloudPubSubNotificationConfig`)`` Cloud Pub/Sub Configuration to receive notifications. |

## CloudPubSubNotificationConfig

The configuration for Pub/Sub messaging for the AppConnector.

| JSON representation |
|---|
| ``` { "pubsubSubscription": string } ``` |

| Fields ||
|---|---|
| `pubsubSubscription` | `string` The Pub/Sub subscription the AppConnector uses to receive notifications. |

## ImageConfig

ImageConfig defines the control plane images to run.

| JSON representation |
|---|
| ``` { "targetImage": string, "stableImage": string } ``` |

| Fields ||
|---|---|
| `targetImage` | `string` The initial image the remote agent will attempt to run for the control plane. Format would be a gcr image path, e.g.: gcr.io/PROJECT-ID/my-image:tag1 |
| `stableImage` | `string` The stable image that the remote agent will fallback to if the target image fails. Format would be a gcr image path, e.g.: gcr.io/PROJECT-ID/my-image:tag1 |